package kadai1;

import java.util.*;

@SuppressWarnings("serial")
public class Search extends KadaiBase {

    public Search() {
        super();
    }

    public String execute() throws Exception {
//        System.out.println(this.getClass().getName() +".execute()");

        if (isInvalid()) {
            addFieldError("inputerr", "͂Ă܂B");
            return INPUT;
        }
        if ( model.id.length() > 9 ) {
            addFieldError("inputerr", "ID9܂łłB");
            return INPUT;
        }

        model.errname = null;
        resultlist = null;
        resultlist = Database.selectData(model);
        if (model.errname != null) {
            addFieldError("inputerr", model.errmessage);
            return INPUT;
        }
        if (resultlist.size()  == 0) {
            addFieldError("inputerr", "Ɉvf[^܂B");
            return INPUT;
        }
        
        return SUCCESS;
    }

    public String edit() throws Exception {
//        System.out.println(this.getClass().getName() +".edit()");
        
        resultlist = null;
        resultlist = Database.selectData(model);
        
        model.copyFrom(resultlist.get(0));
        model.entrymode = "update";
//        System.out.println(model.toString());
        return INPUT;
    }

    private boolean isInvalid() {
        boolean result;
        result = isInvalidString(model.id) & (model.grade <= 1) & isInvalidString(model.mailaddress) & (model.area <= 1);
        return result;
    }
    private boolean isInvalidString(String str) {
        boolean result;
        result = (str == null) || (str.isEmpty());
        return result;
    }
    
    private ArrayList<ModelUserData> resultlist;
    public ArrayList<ModelUserData> getResultlist() {
        return this.resultlist;
    }

}
