package kadai1;

import java.util.ArrayList;
import java.util.Calendar;

public class KadaiList {

    // View̃v_EŎgp
    ArrayList<ListItemData> sex;
    public ArrayList<ListItemData> getSex() {
        return sex;
    }
    ArrayList<ListItemData> year;
    public ArrayList<ListItemData> getYear() {
        return year;
    }
    ArrayList<ListItemData> month;
    public ArrayList<ListItemData> getMonth() {
        return month;
    }
    ArrayList<ListItemData> date;
    public ArrayList<ListItemData> getDate() {
        return date;
    }
    ArrayList<ListItemData> area;
    public ArrayList<ListItemData> getArea() {
        return area;
    }
    ArrayList<ListItemData> prefecture;
    public ArrayList<ListItemData> getPrefecture() {
        return prefecture;
    }
    ArrayList<ListItemData> grade;
    public ArrayList<ListItemData> getGrade() {
        return grade;
    }

    public KadaiList() {
        sex = new ArrayList<ListItemData>();
        sex.add(new ListItemData("1", "j"));
        sex.add(new ListItemData("2", ""));

        year = new ArrayList<ListItemData>();
        {
            year.add(new ListItemData("1", "Iт"));
            Calendar cal = Calendar.getInstance();
            int age = 20;
            int yearnum  = cal.get(Calendar.YEAR);
            year.add(new ListItemData("2", (yearnum - age) + "NȑO")); // 2009̏ꍇ1989
            age--;
            year.add(new ListItemData("3", (yearnum - age) + "N42_" + age + ""));
            age--;
            year.add(new ListItemData("4", (yearnum - age) + "NZ3Ni42_" + age + "΁j"));
            age--;
            year.add(new ListItemData("5", (yearnum - age) + "NZ2Ni42_" + age + "΁j"));
            age--;
            year.add(new ListItemData("6", (yearnum - age) + "NZ1Ni42_" + age + "΁j"));
            age--;
            year.add(new ListItemData("7", (yearnum - age) + "Nw3Ni42_" + age + "΁j"));
            age--;
            year.add(new ListItemData("8", (yearnum - age) + "Nw2Ni42_" + age + "΁j"));
            age--;
            year.add(new ListItemData("9", (yearnum - age) + "Nw1Ni42_" + age + "΁j"));
            age--;
            year.add(new ListItemData("10", (yearnum - age) + "Nw6Ni42_" + age + "΁j"));
            age--;
            year.add(new ListItemData("11", (yearnum - age) + "Nȍ~"));
        }

        month = new ArrayList<ListItemData>();
        month.add(new ListItemData("1", "Iт"));
        month.add(new ListItemData("2", "1"));
        month.add(new ListItemData("3", "2"));
        month.add(new ListItemData("4", "3"));
        month.add(new ListItemData("5", "4"));
        month.add(new ListItemData("6", "5"));
        month.add(new ListItemData("7", "6"));
        month.add(new ListItemData("8", "7"));
        month.add(new ListItemData("9", "8"));
        month.add(new ListItemData("10", "9"));
        month.add(new ListItemData("11", "10"));
        month.add(new ListItemData("12", "11"));
        month.add(new ListItemData("13", "12"));

        date = new ArrayList<ListItemData>();
        date.add(new ListItemData("1", "Iт"));
        date.add(new ListItemData("2", "1"));
        date.add(new ListItemData("3", "2"));
        date.add(new ListItemData("4", "3"));
        date.add(new ListItemData("5", "4"));
        date.add(new ListItemData("6", "5"));
        date.add(new ListItemData("7", "6"));
        date.add(new ListItemData("8", "7"));
        date.add(new ListItemData("9", "8"));
        date.add(new ListItemData("10", "9"));
        date.add(new ListItemData("11", "10"));
        date.add(new ListItemData("12", "11"));
        date.add(new ListItemData("13", "12"));
        date.add(new ListItemData("14", "13"));
        date.add(new ListItemData("15", "14"));
        date.add(new ListItemData("16", "15"));
        date.add(new ListItemData("17", "16"));
        date.add(new ListItemData("18", "17"));
        date.add(new ListItemData("19", "18"));
        date.add(new ListItemData("20", "19"));
        date.add(new ListItemData("21", "20"));
        date.add(new ListItemData("22", "21"));
        date.add(new ListItemData("23", "22"));
        date.add(new ListItemData("24", "23"));
        date.add(new ListItemData("25", "24"));
        date.add(new ListItemData("26", "25"));
        date.add(new ListItemData("27", "26"));
        date.add(new ListItemData("28", "27"));
        date.add(new ListItemData("29", "28"));
        date.add(new ListItemData("30", "29"));
        date.add(new ListItemData("31", "30"));
        date.add(new ListItemData("32", "31"));

        area = new ArrayList<ListItemData>();
        area.add(new ListItemData("1", "Iт"));
        area.add(new ListItemData("2", "kCEk"));
        area.add(new ListItemData("3", "֓"));
        area.add(new ListItemData("4", ""));
        area.add(new ListItemData("5", "ߋE"));
        area.add(new ListItemData("6", "El"));
        area.add(new ListItemData("7", "BE"));
        area.add(new ListItemData("8", "̑"));

        prefecture = new ArrayList<ListItemData>();
        prefecture.add(new ListItemData("1", "Iт", "1"));
        prefecture.add(new ListItemData("2", "kC", "2"));
        prefecture.add(new ListItemData("3", "X", "2"));
        prefecture.add(new ListItemData("4", "茧", "2"));
        prefecture.add(new ListItemData("5", "{錧", "2"));
        prefecture.add(new ListItemData("6", "Hc", "2"));
        prefecture.add(new ListItemData("7", "R`", "2"));
        prefecture.add(new ListItemData("8", "", "2"));
        prefecture.add(new ListItemData("9", "錧", "3"));
        prefecture.add(new ListItemData("10", "Ȗ،", "3"));
        prefecture.add(new ListItemData("11", "Qn", "3"));
        prefecture.add(new ListItemData("12", "ʌ", "3"));
        prefecture.add(new ListItemData("13", "t", "3"));
        prefecture.add(new ListItemData("14", "s", "3"));
        prefecture.add(new ListItemData("15", "_ސ쌧", "3"));
        prefecture.add(new ListItemData("16", "V", "4"));
        prefecture.add(new ListItemData("17", "xR", "4"));
        prefecture.add(new ListItemData("18", "ΐ쌧", "4"));
        prefecture.add(new ListItemData("19", "䌧", "4"));
        prefecture.add(new ListItemData("20", "R", "4"));
        prefecture.add(new ListItemData("21", "쌧", "4"));
        prefecture.add(new ListItemData("22", "򕌌", "4"));
        prefecture.add(new ListItemData("23", "É", "4"));
        prefecture.add(new ListItemData("24", "m", "4"));
        prefecture.add(new ListItemData("25", "Od", "5"));
        prefecture.add(new ListItemData("26", "ꌧ", "5"));
        prefecture.add(new ListItemData("27", "s{", "5"));
        prefecture.add(new ListItemData("28", "{", "5"));
        prefecture.add(new ListItemData("29", "Ɍ", "5"));
        prefecture.add(new ListItemData("30", "ޗǌ", "5"));
        prefecture.add(new ListItemData("31", "a̎R", "5"));
        prefecture.add(new ListItemData("32", "挧", "6"));
        prefecture.add(new ListItemData("33", "", "6"));
        prefecture.add(new ListItemData("34", "R", "6"));
        prefecture.add(new ListItemData("35", "L", "6"));
        prefecture.add(new ListItemData("36", "R", "6"));
        prefecture.add(new ListItemData("37", "", "6"));
        prefecture.add(new ListItemData("38", "쌧", "6"));
        prefecture.add(new ListItemData("39", "Q", "6"));
        prefecture.add(new ListItemData("40", "m", "6"));
        prefecture.add(new ListItemData("41", "", "7"));
        prefecture.add(new ListItemData("42", "ꌧ", "7"));
        prefecture.add(new ListItemData("43", "茧", "7"));
        prefecture.add(new ListItemData("44", "F{", "7"));
        prefecture.add(new ListItemData("45", "啪", "7"));
        prefecture.add(new ListItemData("46", "{茧", "7"));
        prefecture.add(new ListItemData("47", "", "7"));
        prefecture.add(new ListItemData("48", "ꌧ", "7"));
        prefecture.add(new ListItemData("49", "̑", "8"));

        grade = new ArrayList<ListItemData>();
        grade.add(new ListItemData("1", "Iт"));
        grade.add(new ListItemData("2", "Z3NEwZ6NE3N"));
        grade.add(new ListItemData("3", "Z2NEwZ5NE2N"));
        grade.add(new ListItemData("4", "Z1NEwZ4NE1N"));
        grade.add(new ListItemData("5", "w3NEwZ3N"));
        grade.add(new ListItemData("6", "w2NEwZ2N"));
        grade.add(new ListItemData("7", "w1NEwZ1N"));
        grade.add(new ListItemData("8", "w"));
        grade.add(new ListItemData("9", "̑"));

    }

}
